// \[geXg ̂P
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <assert.h>
#ifdef __cplusplus
#include <algorithm>
#endif

#ifndef TYPE
#define TYPE 	int
#endif


#define swap(a,b)	do { TYPE tmp = (a); (a) = (b); (b) = tmp; } while (0)



// ouE\[g
void bubble_sort(TYPE* data, size_t size) {
	size_t	i, j;
	for (i = 0; i < size-1; ++i) {
		for (j = size; --j > i;) {
			if (data[j] < data[j-1])
				swap(data[j], data[j-1]);
		}
	}
}


// I\[g
void selection_sort(TYPE* data, size_t size) {
	size_t	i, j;
	for (i = 0; i < size; ++i) {
	    size_t  min = i;
	    for (j = i+1; j < size; ++j) {
	    	if (data[j] < data[min])
	    		min = j;
	    }
	    swap(data[i], data[min]) ;
	}
}


// }\[g
void insert_sort(TYPE* data, size_t size) {
	size_t	i, j;
	for (i = 1; i < size; ++i) {
		TYPE  	tmp = data[i];
		for (j = i; j > 0 && tmp < data[j-1]; --j)
			data[j] = data[j-1];
		data[j] = tmp;
	}
}


// }\[g (Ȃ炨)
void yane_insert_sort(TYPE* data, size_t size) {
	size_t i, j;
	for (i = 1; i < size; i++) {
		TYPE tmp = data[i];
		if (data[i-1] > tmp) {
			j = i;
			do {
				data[j] = data[j-1];
				--j;
			} while ( j > 0 && data[j-1] > tmp);
			data[j] = tmp;
		}
	}
}


// }\[g(old) 2007܂łwikipediaɍڂĂo[W.
void old_insert_sort(TYPE* data, size_t size) {
	size_t	i, j, k;
	for (i = 0; ++i < size;) {
		for (j = i, k = i-1; j > 0 && data[j] < data[k]; --j, --k)
			swap(data[j], data[k]);
	}
}


// RE\[g
void comb_sort(TYPE* data, size_t size) {
    size_t h    = size * 10 / 13;
    for (;;) {
        int 	swapFlag = 0;
        size_t	i 		 = 0;
        for (i = 0; i + h < size; ++i) {
            if (data[i + h] < data[i]) {
                swap(data[i + h], data[i]);
                swapFlag = 1;
            }
        }
        if (h <= 1) {
            if (!swapFlag)
                break;
        } else {
            h = h * 10 / 13;
        }
    }
}


// RE\[g11
void comb_sort11(TYPE* data, size_t size) {
    size_t 		h		= size * 10 / 13;
    for (;;) {
		size_t	i;
        int 	swapFlag = 0;
        for (i = 0; i + h < size; ++i) {
            if (data[i + h] < data[i]) {
                swap(data[i + h], data[i]);
                swapFlag = 1;
            }
        }
        if (h <= 1) {
            if (!swapFlag)
                break;
        } else if ((h == 9) | (h == 10)) {
			h = 11;
        } else {
            h = h * 10 / 13;
        }
    }
}


// HvȂquick\[g.
void quick_sort(TYPE* data, size_t size) {
	TYPE  m;
	TYPE *l, *r, *e;
	if (size <= 1)
		return;
	m = data[size / 2];
	l = data;
	e = data + size;
	r = e - 1;
	for (;;) {
		while (*l < m)
			++l;
		while (m < *r)
			--r;
		if (l >= r)
			break;
		swap(*l, *r);
		++l;
	}
	quick_sort(data, l - data);
	quick_sort(l   , e - l  );
}



// quick\[g+}\[g (32ȉɂȂ}\[gɐؑ)
void ex_quick_sort(TYPE* data, size_t size) {
	TYPE  m;
	TYPE *l, *r, *e;
	if (size <= 32) {
		if (size <= 1)
			return;
		insert_sort(data, size);
		return;
	}
	m = data[size / 2];
	l = data;
	e = data + size;
	r = e - 1;
	for (;;) {
		while (*l < m)
			++l;
		while (m < *r)
			--r;
		if (l >= r)
			break;
		swap(*l, *r);
		++l;
	}
	ex_quick_sort(data, l - data);
	ex_quick_sort(l   , e - l  );
}



// quick\[g+}\[g (32ȉɂȂ}\[gɐؑ)
void y_quick_sort(TYPE* data, size_t size) {
	TYPE  m;
	TYPE *l, *r, *e;
	if (size <= 32) {
		if (size <= 1)
			return;
		yane_insert_sort(data, size);
		return;
	}
	m = data[size / 2];
	l = data;
	e = data + size;
	r = e - 1;
	for (;;) {
		while (*l < m)
			++l;
		while (m < *r)
			--r;
		if (l >= r)
			break;
		swap(*l, *r);
		++l;
	}
	y_quick_sort(data, l - data);
	y_quick_sort(l   , e - l  );
}



// qsortp̔r֐.
int qsort_cmp(const void* a0, const void* b0) {
	const TYPE* a = (const TYPE* )a0;
	const TYPE* b = (const TYPE* )b0;
	return *a - *b;
}



// CCu qsort gꍇ.
void c_qsort(TYPE* data, size_t size) {
	qsort(data, size, sizeof(TYPE), qsort_cmp);
}



#ifdef __cplusplus
// std::sort gm.
void std_sort(TYPE* data, size_t size) {
	std::sort(data, data+size);
}
#endif



// ===========================================================================

typedef void (*SortFunc)(TYPE*, size_t size);

void benchmark(const char *name, SortFunc sortFunc, int seed, size_t size, size_t count) {
	unsigned i, j, ofs = 0;
    double 	 elapsed, start_time;
	TYPE*	 data    = (TYPE*) malloc(size * sizeof(TYPE) * count);
	srand(seed);
    for (i = 0; i < size * count; ++i)
        data[i] = rand();
    start_time  = clock();
	for (j = 0; j < count; ++j) {
	    sortFunc(&data[ofs], size);
	    ofs        += size;
	}
    elapsed    = clock() - start_time;
    printf("%s:%13.3fʕb (%eb)\n", name, elapsed / (CLOCKS_PER_SEC*count) * 1000000, elapsed / (CLOCKS_PER_SEC*count) );
	free(data);
}


//
int main(int argc, char **argv) {
    size_t size  = (argc >= 2) ? atoi(argv[1]) : 100;
    size_t count = (argc >= 3) ? atoi(argv[2]) : 1;
    int    all   = (argc >= 4) ? atoi(argv[3]) : 0;	// xASY.
    int    seed  = 1; //time(0);
    printf(" %d,  %d\n", size, count);
    if (all) {	// O(n^2)
        benchmark("buble sort       ", &bubble_sort     , seed, size, count);
        benchmark("selection sort   ", &selection_sort  , seed, size, count);
        benchmark("insert sort      ", &insert_sort     , seed, size, count);
        benchmark("insert sort(yane)", &yane_insert_sort, seed, size, count);
    }
    {			// O(n log n)
    	benchmark("comb sort        ", &comb_sort       , seed, size, count);
    	benchmark("comb sort11      ", &comb_sort11     , seed, size, count);
    	benchmark("quick sort       ", &quick_sort      , seed, size, count);
    	benchmark("quick+insert sort", &ex_quick_sort   , seed, size, count);
    	benchmark("quick+yane-insert", &y_quick_sort    , seed, size, count);
	  #ifdef __cplusplus
    	benchmark("std::sort        ", &std_sort        , seed, size, count);
	  #endif
    	benchmark("qsort            ", &c_qsort         , seed, size, count);
	}
    return 0;
}
